/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.userBank.wrapper;

import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.modules.guosen.loginUser.entity.LoginUser;
import org.springblade.modules.guosen.loginUser.service.ILoginUserService;
import org.springblade.modules.guosen.loginUser.vo.LoginWebVO;
import org.springblade.modules.guosen.userBank.entity.UserBank;
import org.springblade.modules.guosen.userBank.vo.UserBankVO;
import java.util.Objects;
import java.util.Optional;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-07-07
 */
public class UserBankWrapper extends BaseEntityWrapper<UserBank, UserBankVO>  {

	private ILoginUserService loginUserService;

	public UserBankWrapper(ILoginUserService loginUserService) {
		this.loginUserService = loginUserService;
	}

	public static UserBankWrapper build(ILoginUserService loginUserService) {
		return new UserBankWrapper(loginUserService);
 	}

	@Override
	public UserBankVO entityVO(UserBank userBank) {
		UserBankVO userBankVO = Objects.requireNonNull(BeanUtil.copy(userBank, UserBankVO.class));
		if (userBankVO != null) {
			LoginUser loginUser  = loginUserService.getById(userBankVO.getUserId());
			LoginWebVO loginWebVO = new LoginWebVO();
			if (loginUser != null) {
				BeanUtil.copyProperties(loginUser, loginWebVO);
			}
			userBankVO.setLoginWebVO(loginWebVO);
		}

		return userBankVO;
	}

}
